get_filename_component(amcl_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)

set(AMCL_LIBRARIES "amcl_core;amcl_x509;amcl_rsa_2048;amcl_rsa_3072;amcl_rsa_4096;amcl_curve_ANSSI;amcl_curve_BLS383;amcl_curve_BLS461;amcl_curve_BN254;amcl_curve_BN254CX;amcl_curve_BRAINPOOL;amcl_curve_C25519;amcl_curve_C41417;amcl_curve_ED25519;amcl_curve_FP256BN;amcl_curve_FP512BN;amcl_curve_GOLDILOCKS;amcl_curve_HIFIVE;amcl_curve_NIST256;amcl_curve_NIST384;amcl_curve_NIST521;amcl_curve_NUMS256E;amcl_curve_NUMS256W;amcl_curve_NUMS384E;amcl_curve_NUMS384W;amcl_curve_NUMS512E;amcl_curve_NUMS512W;amcl_pairing_BLS383;amcl_pairing_BLS461;amcl_pairing_BN254;amcl_pairing_BN254CX;amcl_pairing_FP256BN;amcl_pairing_FP512BN;amcl_mpin_BLS383;amcl_mpin_BLS461;amcl_mpin_BN254;amcl_mpin_BN254CX;amcl_mpin_FP256BN;amcl_mpin_FP512BN;amcl_wcc_BLS383;amcl_wcc_BLS461;amcl_wcc_BN254;amcl_wcc_BN254CX;amcl_wcc_FP256BN;amcl_wcc_FP512BN")

if(NOT TARGET AMCL::AMCL)
  include("${amcl_CMAKE_DIR}/AMCLTargets.cmake")

  # Add change prefix to get target names
  foreach(_lib ${AMCL_LIBRARIES})
    string(REGEX REPLACE "^amcl_" "AMCL::" _target "${_lib}")
    list(APPEND AMCL_TARGETS "${_target}")
  endforeach()

  # Create an uber-target depending on all install AMCL libraries
  add_library(AMCL::AMCL INTERFACE IMPORTED)
  set_target_properties(AMCL::AMCL PROPERTIES INTERFACE_LINK_LIBRARIES "${AMCL_TARGETS}")
endif()

# If components were specified, determine which were actually found.
if(AMCL_FIND_COMPONENTS)
  foreach(comp ${AMCL_FIND_COMPONENTS})
    if(TARGET "AMCL::${comp}")
      set(AMCL_${comp}_FOUND 1)
    else()
      set(AMCL_${comp}_FOUND 0)
      if(AMCL_FIND_REQUIRED_${comp})
        message(FATAL_ERROR "AMCL::${comp} not available.")
      endif()
    endif()
  endforeach()
endif()
